Graphics3D 800,600,32,2
SetBuffer BackBuffer()

SeedRnd MilliSecs()

SetFont LoadFont(Arial,12)

;  
pxCreateWorld(1,"")
pxSetGravity(0,-10,0)


; 
cam=CreateCamera()
PositionEntity cam,0,15,-25
RotateEntity cam,25,0,0

; 
light=CreateLight()
PositionEntity light,10,10,-10

; 
plane=CreatePlane()
EntityAlpha plane,0.8
EntityColor plane,150,255,255
CreateMirror()

;================================================

For i=0 To 15
	CreatepxCube(Rnd(-10,10),15,Rnd(-10,10))
Next

mag1=pxCreateMagnet(1,5,10)   		;  
pxMagnetSetMaxRadius(mag1, 15)      ;     
pxMagnetSetPosition(mag1,-10,0,0)   ;   
pxMagnetSetMask(mag1,2)             ;  

explode=pxCreateMagnet(0,-20,-50)   ;  
pxMagnetSetMaxRadius(explode, 15)   ;    
pxMagnetSetMask(explode,3)          ;  

sp =CreateSphere()
ScaleEntity sp,0.8,0.8,0.8
EntityColor sp,0,0,255

explode_sp=CreateSphere()
EntityColor explode_sp,250,200,100

x#=-10
z#=0
p%=1
boom%=0
rad#=0

While Not KeyDown(1)	
	
	If KeyDown (205) x# = x#+0.2
	If KeyDown (203) x# = x#-0.2
	If KeyDown (200) z# = z#+0.2
	If KeyDown (208) z# = z#-0.2
		
	If KeyDown(57) pxMagnetActivate(mag1,0,0)
	
	If KeyHit(28) p=-p
	
	pxMagnetSetMinForce(mag1, 1*p)
	pxMagnetSetMidForce(mag1, 5*p)
	pxMagnetSetMaxForce(mag1, 10*p)
	pxMagnetSetPosition(mag1, x, y, z)
	
	PositionEntity sp, x,y,z
	If p=1
		EntityColor sp,0,0,255
		Else
		EntityColor sp,255,0,0
	EndIf
	
	If KeyHit(18) And boom=0 
		pxMagnetActivate(explode,0,1)
		boom=1
	EndIf
	
	If boom=1
		rad=rad+2
	    ScaleEntity explode_sp,rad,rad,rad
	    If rad>200 boom=0
	Else
		rad=Abs(Sin(MilliSecs()*0.2))+0.5
		ScaleEntity explode_sp,rad,rad,rad    
	EndIf
	
	If KeyHit(15) 
		DeletepxCubes() 
		For i=0 To 15
			CreatepxCube(Rnd(-10,10),15,Rnd(-10,10))
		Next
	EndIf

	
	pxRenderPhysic(60,0)
	UpdatepxCubes()
	RenderWorld
	
	Text 10,FontHeight()*1,"cursor - move magnet"
	Text 10,FontHeight()*2,"space - activate magnet"
	Text 10,FontHeight()*3,"enter - change polarity"
	Text 10,FontHeight()*4,"e - explode"	
	Flip
Wend
End

Type pxCube
	Field mesh
	Field body	
End Type

Function CreatepxCube(x#,y#,z#)
	pxC.pxCube = New pxCube
	pxC\mesh = CreateCube()
	pxC\body = pxBodyCreateCube(1,1,1,1)	
	pxBodySetPosition pxC\body,x,y,z
	
	Metall=Rand(0,1)
	If Metall
		EntityColor pxC\mesh,230,232,215
		pxBodySetMagnetMask(pxC\body, 2) ;bin(10)
	Else
		EntityColor pxC\mesh,128,64,64
		pxBodySetMagnetMask(pxC\body, 1) ;bin(01)
	EndIf
		
End Function

Function UpdatepxCubes()
	For pxC.pxCube = Each pxCube
		pxBodySetEntity pxC\mesh, pxC\body
	Next
End Function

Function DeletepxCubes()
	For pxC.pxCube = Each pxCube
	FreeEntity pxC\mesh 
	pxDeleteBody pxC\body 
	Delete pxC		
	Next
End Function